unit main;

// SIPInside, Delphi SoftPhone for freephonie.net (c)2006 by Paul TOTH <tothpaul@free.fr>
// http://tothpaul.free.fr

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

{
 version 0.4.1
  - gestion des sessions SIP
  - ajout d'une indicateur de paquet entrant

 version 0.4.0
  - modification de l'interface graphique
  - ajout du support des appels entrant par Fritivi (http://fritivi.free.fr)
  - ajout du test sonore

 version 0.3.3
  - ajout de l'historique des 15 derniers appels

 version 0.3.2
  - merci  Nicolas qui m'a ouvert les yeux !
  - la session audio doit dmarrer ds que possible (document SDP), ce qui peut se
    produire lors du TRYING, donc bien que le correspondant dcroche.
    Du coup, on a maintenant la sonnerie :D
  - suppression du CloseOut en fin de ThreadProc qui plantait parfois le PCMA.Close  

 version 0.3.1
  - ajout de l'URL de version
  - utilise le MD5 par dfault (rend SIPInside compatible avec sip.1und1.de).
  - validation du numro de tlphone par ENTREE pour une question d'accessibilit

 version 0.3.0
  - utilisation de REGISTER
  - ajout du carnet d'adresses (.INI qui remplace les paramtres)
  - NB: pour limiter la taille de l'executable, j'ai remplac un TPageControl (24Ko en plus !) par
        une srie de TPanel...C'est moins pratique au design, mais c'est visuellement la mme chose.
  - l'unit IniFiles du projet rduit l'executation de 4Ko par rapport  l'orginale.

 version 0.2.3
  - ajout des paramtres  -p -i -o

 version 0.2.2
  - ajout du raccourci

 version 0.2.1
  - ajout de STUN pour dterminer l'adresse IP publique
  - dtection des priphriques audio par dfaut
  - rafraichissement des listes de priphriques (WM_DEVICECHANGE)
  - suppression de l'aide en ligne pour passer en dessous des 500Ko :D

 version 0.2   - premire release des sources
}

{-$DEFINE CONSOLE} // debug SIP protocol

interface

uses
  Windows, Messages,
  Forms, Graphics, Classes,
  Controls, StdCtrls, ExtCtrls, ComCtrls,
  SysUtils, Dialogs,
  MMSystem, ShellAPI, Winsock,
  IniFiles,
  ExButtons, ExPageControl,
  SIP, RTP, RTCP, g711a, STUN, PhoneBookFrame, PhoneBookEntryFrame,
  OptionsFrame;

type
  TTab=(
  tUsers,
  tConnexion, tStatus, tWait,
  tCall,
  tabPhoneBook,
  tCallHistory,
  tIncoming,
  tabOptions,
  tHelp
  );
  TTabs=set of TTab;

  TMainForm = class(TForm)
    SIPInside: TLabel;
    TelephoneIP: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    UserID: TEdit;
    Password: TEdit;
    Domain: TEdit;
    PaulToth: TLabel;
    MyAccount: TLabel;
    ShapeAccount: TShape;
    Status: TLabel;
    Label11: TLabel;
    Username: TEdit;
    n1: TLabel;
    n2: TLabel;
    n3: TLabel;
    n6: TLabel;
    n4: TLabel;
    n5: TLabel;
    n9: TLabel;
    n7: TLabel;
    n8: TLabel;
    nSharp: TLabel;
    nStar: TLabel;
    n0: TLabel;
    na: TLabel;
    nb: TLabel;
    nc: TLabel;
    nd: TLabel;
    PaintBox1: TPaintBox;
    lbAddr: TLabel;
    Addr: TEdit;
    SaveDlg: TSaveDialog;
    STUNResponse: TLabel;
    TalkTime: TLabel;
    CallHistoryList: TListBox;
    CallHistoryClear: TButton;
    lblHistoryCallType: TLabel;
    LblHistoryCallTime: TLabel;
    lblHistoryCallLength: TLabel;
    lblHistoryCallNumber: TLabel;
    Label1: TLabel;
    AcceptIncomingCall: TButton;
    Label18: TLabel;
    RefuseIncomingCall: TButton;
    TimerSonnerie: TTimer;
    CallerID: TLabel;
    PageControl: TPageControl;
    ConnexionPage: TTabSheet;
    PhoneBookPage: TTabSheet;
    CallHistoryPage: TTabSheet;
    IncomingPage: TTabSheet;
    TabSheet5: TTabSheet;
    Connect: TButton;
    Cancel: TButton;
    OptionsPage: TTabSheet;
    WaitPage: TTabSheet;
    UsersPage: TTabSheet;
    UserList: TListBox;
    SelectUser: TButton;
    NewUser: TButton;
    CallPage: TTabSheet;
    Hangup: TButton;
    StatusPage: TTabSheet;
    Label8: TLabel;
    ConnectedName: TLabel;
    ConnectedID: TLabel;
    Disconnect: TButton;
    PhoneBook: TPhoneBook;
    PhoneBookEntry: TPhoneBookEntry;
    Version: TButton;
    Memo1: TMemo;
    DoNotDisturb2: TCheckBox;
    Options: TOptions;
    Shape1: TShape;
    Shape2: TShape;
    InCount: TLabel;
    OutCount: TLabel;
    procedure MyAccountClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ConnectClick(Sender: TObject);
    procedure CancelClick(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure n1MouseEnter(Sender: TObject);
    procedure n1MouseLeave(Sender: TObject);
    procedure nSharpClick(Sender: TObject);
    procedure n1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure n1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure PaulTothClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure VersionCheckClick(Sender: TObject);
    procedure CallHistoryClearClick(Sender: TObject);
    procedure AcceptIncomingCallClick(Sender: TObject);
    procedure RefuseIncomingCallClick(Sender: TObject);
    procedure TimerSonnerieTimer(Sender: TObject);
    procedure CallHistoryListDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure SelectUserClick(Sender: TObject);
    procedure PhoneBookPageShow(Sender: TObject);
    procedure CallHistoryPageShow(Sender: TObject);
    procedure DisconnectClick(Sender: TObject);
    procedure HangupClick(Sender: TObject);
    procedure DoNotDisturbClick(Sender: TObject);
  private
    { Private declarations }
    RTP :TRTPClient;  // RTP protocol
    RTCP:TRTCPClient; // RTCP protocol
    STUN:TSTUNClient;
//    fActivePage:integer;
    CallDate:TDateTime;
    CallTime:cardinal;
    fTabs   :TTabs;
    procedure ReadCallHistory;
    procedure WMSIPMessage(var Msg); message WM_USER+1; // SIP Callback message
    procedure WMSTUNMessage(var Msg); message WM_USER+2; // STUN Callback message
    procedure WMPCMAMessage(var Msg:TMessage); message WM_USER+3; // PCMA Callback message
    procedure WAVEInData(Var Msg:TMessage); message MM_WIM_DATA; // waveIn callback message
    procedure WMDeviceChange(Var Msg:TMessage); message WM_DEVICECHANGE;
    procedure OnError(Sender:TObject);
   {$IFDEF CONSOLE}
    procedure OnSend(Sender:TObject);
    procedure OnRecv(Sender:TObject);
   {$ENDIF}
    procedure OnStep(Sender:TObject);
    procedure OnOpen(Sender:TObject);
    procedure OnStart(Sender:TObject);
    procedure OnStop(Sender:TObject);
    procedure OnBind(Sender:TObject);
    procedure StartRinging;
    procedure StopRinging;
    procedure LoadUser(const id:string);
  public
    { Public declarations }
    Ini :TIniFile;
    SIP :TSIPClient;  // SIP protocol
    PCMA:TPCMA;       // g711a codes
    procedure SetTabs(Visible:TTabs; Active:TTab);
    property Tabs:TTabs read fTabs;
    procedure Dial(const Number:string);
  end;

  function GetPar(chaine:string;position:integer;cSeparator:Char=#9):string;

var
  MainForm: TMainForm;

implementation

uses UDP, SoudTest;

{$R *.dfm}

type
// pour accder aux membres protgs de TPageControl
 TOpenPageControl=class(TPageControl)
 end;

procedure TMainForm.FormCreate(Sender: TObject);
var
 s:string;
begin
 Caption:=SIP_VERSION+' - Un client SIP pour Freenaute';

 TOpenPageControl(PageControl).Ctl3D:=False;

 SIP:=TSIPClient.Create(Handle,WM_USER+1);
 SIP.OnError:=OnError;
 SIP.OnStep:=OnStep;
 SIP.OnOpen:=OnOpen;
 SIP.OnStart:=OnStart;
 SIP.OnStop:=OnStop;

{$IFDEF CONSOLE}
// AssignFile(Output,'SIPInside-SIP.log');
// Rewrite(Output);
 AllocConsole;
 SIP.OnSend:=OnSend;
 SIP.OnRecv:=OnRecv;
{$ENDIF}


 RTP :=TRTPClient.Create;
 RTCP:=TRTCPClient.Create(RTP);
 PCMA:=TPCMA.Create(Handle); // Handle needed for waveIn callback message

 Addr.Text:=RTP.LocalAddr;
 SIP.SetLocal(RTP.LocalAddr,RTP.Port);

 STUN:=TSTUNClient.Create(Handle,WM_USER+2);
 STUN.OnBind:=OnBind;
 STUN.Request('stun.fwdnet.net');

 Options.CheckDevices;

// save current label (see Cancel.Click)
 Status.Hint:=Status.Caption;
 Cancel.Hint:=Cancel.Caption;

// PageControl.ActivePageIndex:=0;
// ActivePage:=0;

 // first, read from INI file
 Ini:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
 Ini.ReadSection('Accounts',UserList.Items);
 if UserList.Items.Count>1 then exit;
 if UserList.Items.Count=0 then
  s:=Ini.ReadString('SIPInside','LastID','')
 else begin
  s:=UserList.Items[0];
  s:=Ini.ReadString('Accounts',s,s);
 end;
 LoadUser(s);
end;

procedure TMainForm.SetTabs(Visible:TTabs; Active:TTab);
var
 i:integer;
begin
 fTabs:=Visible;
 for i:=0 to PageControl.PageCount-1 do begin
  PageControl.Pages[i].TabVisible:=word(Visible) and (1 shl i)>0;
 end;
 PageControl.ActivePageIndex:=ord(Active);
end;

procedure TMainForm.WMDeviceChange(Var Msg:TMessage);
begin
// ne pas rafraichir la liste en cours de conversation
 //if PageControl.ActivePageIndex=0 then CheckDevices else ConnexionPanel.Tag:=1;
// if fActivePage=0 then CheckDevices else ConnexionPanel.Tag:=1;
end;

procedure TMainForm.MyAccountClick(Sender: TObject);
begin
 ShellExecute(0,nil,'http://subscribe.free.fr/login/',nil,nil,SW_SHOW);
end;

procedure TMainForm.VersionCheckClick(Sender: TObject);
begin
 ShellExecute(0,nil,pchar('http://tothpaul.free.fr/SIPInside.php?'+URLEncode(SIP_RELEASE)),nil,nil,SW_SHOW);
end;

procedure TMainForm.PaulTothClick(Sender: TObject);
begin
 ShellExecute(0,nil,'http://tothpaul.free.fr/',nil,nil,SW_SHOW);
end;

procedure TMainForm.ConnectClick(Sender: TObject);
begin
 if Username.Text='' then begin
  ShowMessage('Veuillez indiquer votre pseudo');
  Username.SetFocus();
  exit;
 end;
 if UserId.Text='' then begin
  ShowMessage('Veuillez indiquer votre identifiant SIP (08 7x xx xx xx)');
  UserId.SetFocus();
  exit;
 end;
 if Password.Text='' then begin
  ShowMessage('Veuillez indiquer votre mot de passe SIP');
  Password.SetFocus();
  exit;
 end;
 if Domain.Text='' then begin
  ShowMessage('Veuillez indiquer votre domaine SIP (freephonie.net)');
  Domain.SetFocus();
  exit;
 end;
 SetTabs(fTabs+[tWait]-[tConnexion],tWait);
// lancer le login SIP (voir SIP.OnXXX, CancelClick pour la suite)
 SIP.Login(Username.Text,Domain.Text,UserID.Text,Password.Text);
end;

procedure TMainForm.CancelClick(Sender: TObject);
begin
// premier cancel
 if Cancel.Tag=0 then begin
  SIP.Cancel; // voir SIP.OnXXX pour les changements
  RTCP.Leave;
  PCMA.Close;
 end else begin
  SetTabs([tConnexion,tabPhoneBook,tCallHistory,tabOptions,tHelp],tConnexion);
 end;
end;

procedure TMainForm.EditKeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then begin
  Key:=#0;
  ConnectClick(Self);
 end else begin
  if (TEdit(Sender).Tag=1)and(not (Key in [#8,'0'..'9'])) then Key:=#0;
 end;
end;

procedure TMainForm.OnError(Sender:TObject);
begin
 case SIP.Error of
  SIP_HOST_NOT_FOUND  : ShowMessage('Domain introuvable : '+SIP.Domain);
  SIP_NO_SOCKET       : ShowMessage('Problme d''ouverture de socket');
  SIP_SEND_ERROR      : ShowMessage('Erreur d''criture');
  SIP_RECV_ERROR      : ShowMessage('Erreur de lecture');
  SIP_INVALID_RESPONSE: ShowMessage('Rponse invalide'#13+SIP.Head);
  SIP_UNAUTHORIZED    : ShowMessage('Accs refus');
  SIP_NOT_CONNECTED   : ShowMessage('Opration hors contexte');
  else ShowMessage('SIP Error #'+IntToStr(SIP.Error));
 end;
end;

{$IFDEF CONSOLE}
procedure TMainForm.OnSend(Sender:TObject);
begin
// AllocConsole;
 WriteLn('<--SEND-->');
 WriteLn(SIP.Send);
end;

procedure TMainForm.OnRecv(Sender:TObject);
begin
// AllocConsole;
 WriteLn('<--RECV from '+inet_ntoa(SIP.From.sin_addr)+':'+IntToStr(htons(SIP.From.sin_port))+' -->');
 WriteLn(SIP.Head);
 Write('<---');
 Write(SIP.Data);
 WriteLn('--->');
end;
{$ENDIF}

procedure TMainForm.OnStep(Sender:TObject);
{$IFDEF CONSOLE}
const
 Steps:array[TSIPStep] of string=(
  'csNONE',
  'csREGISTER',
  'csREGISTERED',
  'csINVITE',
  'csAUTH',
  'csTRYING',
  'csWRONG',
  'csRINGING',
  'csCANCEL',
  'csCANCELED',
  'csUNAVAILABLE',
  'csONLINE',
  'csSENDBYE',
  'csRECVBYE',
  'csRECVINVITE',
  'csCALLREFUSED',
  'csCALLACCEPTED',
  'csRECVCANCEL'
 );
{$ENDIF}
begin
{$IFDEF CONSOLE}
 Caption:=Steps[SIP.Step];
{$ENDIF}
 case SIP.Step of
  csNONE       : SetTabs([tConnexion,tabPhoneBook,tCallHistory,tabOptions,tHelp],tConnexion);
  csREGISTER   : Status.Caption:='connexion en cours...';
  csREGISTERED : begin
                   ConnectedName.Caption:=SIP.Name;
                   ConnectedID.Caption:=SIP.UserID+'@'+SIP.Domain;
                   SetTabs([tStatus,tabPhoneBook,tCallHistory,tabOptions,tHelp],tabPhoneBook);
                 end;
  csINVITE     : Status.Caption:='attente du serveur...';
  csTRYING     : Status.Caption:='appel en cours...';
  csRINGING    : Status.Caption:='a sonne...';
  csCANCEL     : Status.Caption:='Appel annul...';
  csCANCELED   : begin
   Status.Caption:='l''appel n''a pas abouti';
   if STUNResponse.Visible then Status.Caption:=Status.Caption+', vrifiez votre firewall';
  end;
  csUNAVAILABLE: Status.Caption:='Serveur temporairement Indisponible';
  csONLINE     : begin
   SetTabs([tCall,tHelp],tCall);
   CallDate:=Now;
   CallTime:=GetTickCount;
   if PCMA.OpenIn=False then
    CancelClick(Self); // en version 0.3.2, PCMA.Listen() est dmarr plus tt
  end;
  csSENDBYE    : Status.Caption:='on raccroche...';
  csRECVBYE    : Status.Caption:='Votre correspondant a raccroch';
  csWRONG      : Status.Caption:='Identifiant ou mot de passe invalide !';
  csRECVINVITE : begin
                  CallerID.Caption:=SIP.Caller;
                  SetTabs([tIncoming,tHelp],tIncoming);
                  StartRinging;
                  Application.Restore;
                 end;
  csCALLREFUSED : begin
                   StopRinging;
                   SetTabs([tConnexion,tabPhoneBook,tabOptions,tHelp],tConnexion);
                   Status.Caption:='Appel Refus';
                  end;
  csCALLACCEPTED: begin
                   StopRinging;
                  end;
  csRECVCANCEL  : begin
                   StopRinging;
                   SetTabs([tConnexion,tabPhoneBook,tabOptions,tHelp],tConnexion);
                   Status.Caption:='Appel manqu !'+#13+SIP.Phone;
                  end;
 end;
// if SIP.Step=csONLINE then WaitPanel.Height:=225 else WaitPanel.Height:=113;
end;

procedure TMainForm.OnOpen(Sender:TObject);
begin
// update INI
 Ini.WriteString('SIPInside','LastID',SIP.UserID);
 Ini.WriteString(SIP.UserID,'Name',SIP.Name);
 if Options.RememberPassword.Checked then
  Ini.WriteString(SIP.UserID,'Pass','{'+SIP.Crunch(SIP.UserID,SIP.Domain,Password.Text)+'}')
 else
  Ini.DeleteKey(SIP.UserID,'Pass');
 Ini.WriteString(SIP.UserID,'Domain',SIP.Domain);
 Ini.WriteString(SIP.UserID,'WaveIn',Options.WaveInName);
 Ini.WriteString(SIP.UserID,'WaveOut',Options.WaveOutName);
 Ini.WriteBool(SIP.UserID,'DoNotDisturb',Options.DoNotDisturb.Checked);
end;

procedure TMainForm.OnStart(Sender:TObject);
var
 s:string;
 i:integer;
 p:integer;
begin
 s:=SIP.RemoteSDP;
// quick check for Freephonie.net only ! don't expect that to work with any SIP server !!!
// port
 i:=pos('m=audio ',s);
 if i=0 then exit;
 s:=copy(s,i+8,MaxInt);
 val(s,p,i);
// ip
 s:=SIP.RemoteSDP;
 i:=pos('c=IN IP4 ',s);
 if i=0 then exit;
 s:=copy(s,i+9,MaxInt);
 i:=pos(#13,s);
 SetLength(s,i-1);
 RTCP.Start(s,p);   // create sockets
 PCMA.Listen(WM_USER+3,RTCP); // start waveIn/waveOut
 RTCP.Enter;        // send initial RTP Payload
end;

procedure TMainForm.OnStop(Sender:TObject);
const
 CallTypes:array[TSIPCallType ] of string=(
  'Entrant',
  'Sortant',
  'Manqu'
 );
var
 s,mrc:string;
 key:char;
 Dummy:Word;
 Year:Word;
begin
 s:=SIP.UserID+'.Calls';
 mrc:=Ini.ReadString(s,'MRC','');
 if length(mrc)<15 then begin
  key:=chr(ord('A')+Length(mrc));
  mrc:=key+mrc;
 end else begin
  key:=mrc[15];
  move(mrc[1],mrc[2],14);
  mrc[1]:=key;
 end;
 Ini.WriteString(s,'MRC',mrc);
 // If call has not been established the call date is now...
 DecodeDateFully(CallDate, Year, Dummy, Dummy, Dummy);
 If Year<2000 then
 begin
  CallDate:=Now;
  TalkTime.Caption:='--:--';
 end;
 Ini.WriteString(s,key,DateTimeToStr(CallDate)+#9+TalkTime.Caption+#9+SIP.Phone+#9+CallTypes[SIP.CallType]);
 RTCP.Leave;
 PCMA.Close;
 // If Call Type = missed we need the Cancel
 If SIP.CallType<>ctMISSED then Cancel.Tag:=1;
 Cancel.Caption:='FERMER';
 SetTabs(fTabs-[tCall]+[tWait],tWait);
end;

procedure TMainForm.OnBind(Sender:TObject);
var
 s:string;
begin
 s:=inet_ntoa(in_addr(STUN.Address));
 if Addr.Text<>s then begin
  Addr.Text:=s;
  lbAddr.Caption:='Votre adresse IP publique :';
  SIP.SetLocal(s,RTP.Port);
 end;
 STUNResponse.Hide;
end;

procedure TMainForm.WMSIPMessage(var Msg);
begin
 SIP.ProcessMessage(Msg);
end;

procedure TMainForm.WMSTUNMessage(var Msg);
begin
 STUN.ProcessMessage(Msg);
end;

procedure TMainForm.WMPCMAMessage(var Msg:TMessage);
var
 cl:TColor;
begin
 case Msg.wParam of
  0: cl:=clYellow;
  1: cl:=clLime;
  2: cl:=clWhite;
 end;
 if Shape1.Brush.Color=cl then
  Shape1.Brush.Color:=clWhite
 else
  Shape1.Brush.Color:=cl;
end;

function IntToStr2(i:integer):string;
begin
 Str(i,Result);
 if Length(Result)=1 then Result:='0'+Result;
end;

procedure TMainForm.WAVEInData(Var Msg:TMessage);
// waveIn callback
var
 Header:PWaveHdr;
 maxamp:integer;
 time  :cardinal;
 h,m   :cardinal;
 str   :string;
begin
// on en profite pour mettre  jour le Timer
 time:=(GetTickCount-CallTime) div 1000;
 m:=(time div 60); dec(time,m*60);
 h:=(m div 60); dec(m,60*h);
 if h>0 then str:=IntToStr(h)+':' else str:='';
 TalkTime.Caption:=str+IntToStr2(m)+':'+IntToStr2(time);
// on y va
 Header:=pointer(Msg.LParam);
 maxamp:=DrawSound(Header.lpData,PaintBox1.Canvas,clLime);
// enought amplitude ?
 if maxamp>1 then
 // send buffer to the remote client
  PCMA.WaveInMessage(Msg.wParam,Header)
 else
 // just add the buffer to the listen queue
  waveInAddBuffer(Msg.wParam,Header,SizeOf(TWaveHdr));
end;

procedure TMainForm.n1MouseEnter(Sender: TObject);
begin
// keypad color when mouse is over
 TLabel(Sender).Color:=clRed;
end;

procedure TMainForm.n1MouseLeave(Sender: TObject);
begin
// keypad color when mouse leave (or is not over)
 TLabel(Sender).Color:=$001600DB;
end;

procedure TMainForm.nSharpClick(Sender: TObject);
begin
// play/send DTMF
 PCMA.SendDTMF(TLabel(Sender).Tag);
end;

procedure TMainForm.n1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
// keypad color when clicked
 TLabel(Sender).Color:=clYellow;
end;

procedure TMainForm.n1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
// keypad color when click is done
 TLabel(Sender).Color:=clRed;
end;

procedure TMainForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
// autoriser la touche echappement dans tous les cas
 if Key=#27 then begin
  //if fActivePage=4 then ActivePage:=2 else
  //if fActivePage=3 then ActivePage:=2 else
//  CancelClick(Self);
//  exit;
 end;
// gestion du paver numrique quand on est en ligne
 if SIP.Step=csONLINE then begin
  case Key of
   '0'..'9': PCMA.SendDTMF(Ord(Key)-Ord('0'));
   '*'     : PCMA.SendDTMF(10);
   '#','.' : PCMA.SendDTMF(11);
   'a'..'d': PCMA.SendDTMF(Ord(Key)-Ord('a')+12);
   'A'..'D': PCMA.SendDTMF(Ord(Key)-Ord('A')+12);
  end;
  exit;
 end;
// autoriser la touche ENTREE sur le bouton ANNULER lorsque c'est un message d'tat
// if (Key=#13)and(Cancel.Tag>0) then CancelClick(Self);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
 SIP.Free;
 RTP.Free;
 RTCP.Free;
 PCMA.Free;
 Ini.Free;
end;

procedure TMainForm.ReadCallHistory;
var
 sec:string;
 mrc:string;
   i:integer;
   s:string;
begin
 sec:=UserID.Text+'.Calls';
 mrc:=Ini.ReadString(sec,'MRC','');
 CallHistoryList.Items.Clear;
 for i:=1 to Length(mrc) do begin
  s:=Ini.ReadString(sec,mrc[i],'');
  if s<>'' then CallHistoryList.Items.Add(s);
 end;
end;

procedure TMainForm.CallHistoryClearClick(Sender: TObject);
begin
 Ini.EraseSection(SIP.UserID+'.Calls');
 CallHistoryList.Items.Clear;
end;

procedure TMainForm.AcceptIncomingCallClick(Sender: TObject);
begin
 SIP.AnswerCall;
end;

procedure TMainForm.RefuseIncomingCallClick(Sender: TObject);
begin
 SIP.RefuseCall;
end;

procedure TMainForm.StartRinging;
begin
 // Active la sonnerie
 TimerSonnerie.Enabled:=True;
end;

procedure TMainForm.StopRinging;
begin
 // Dsactive la sonnerie
 TimerSonnerie.Enabled:=False;
end;

procedure TMainForm.TimerSonnerieTimer(Sender: TObject);
begin
 Beep;
 sleep(50);
 Beep;
 sleep(50);
 Beep;
end;


function GetPar(chaine:string;position:integer;cSeparator:Char=#9):string;
var
  texte     : string;
  Compteur  : integer;
begin
  Compteur  := 1;
  Texte     := chaine;
  if position > -1 then
  begin
    While ((pos(cSeparator,texte)<>0) and (Compteur<position)) do
          begin
            texte:=copy(texte,pos(cSeparator,texte)+1,length(texte));
            Inc(Compteur);
          end;
    If ((Compteur=Position) and (pos(cSeparator,texte)=0))
          then Result := Texte
          else Result := copy(texte,1,pos(cSeparator,texte)-1);
  end else
  if pos(cSeparator,texte) <> 0 then begin
    Result := copy(chaine, 1, pos(cSeparator,Chaine)-1);
  end;
end;

procedure TMainForm.CallHistoryListDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
const
 DEC_TOP=1;
var
 sItemText:String;
begin
 sItemText:=(Control as TListBox).Items[Index];
 with (Control as TListBox).Canvas do begin
  FillRect(Rect);
  Brush.Style:=bsClear;
  TextOut(lblHistoryCallType.Left,Rect.Top+DEC_TOP,GetPar(sItemText,4));
  TextOut(LblHistoryCallTime.Left,Rect.Top+DEC_TOP,GetPar(sItemText,1));
  TextOut(lblHistoryCallLength.Left,Rect.Top+DEC_TOP,GetPar(sItemText,2));
  TextOut(lblHistoryCallNumber.Left,Rect.Top+DEC_TOP,GetPar(sItemText,3));
 end;
end;

procedure TMainForm.SelectUserClick(Sender: TObject);
var
 i:integer;
 s:string;
begin
 UserName.Text:='Anonymous';
 UserID.Text:='087';
 Password.Text:='';
 Domain.Text:='freephonie.net';
 if TButton(Sender).Tag=1 then begin
  i:=UserList.ItemIndex;
  if i<0 then exit;
  s:=UserList.Items[i];
  s:=Ini.ReadString('Accounts',s,'');
  if s='' then begin
   ShowMessage('Ce compte est invalide');
   Ini.DeleteKey('Accounts',s);
   Ini.ReadSection('Accounts',UserList.Items);
   exit;
  end;
  UserName.Text:=Ini.ReadString(s,'Name',UserName.Text);
  LoadUser(s);
 end;
 SetTabs([tConnexion,tabPhoneBook,tCallHistory,tabOptions,tHelp],tConnexion);
end;

procedure TMainForm.LoadUser(const id:string);
begin
 UserName.Text:=Ini.ReadString(id,'Name',UserName.Text);
 UserID.Text:=id;
 Password.Text:=Ini.ReadString(id,'Pass','');
 Options.RememberPassword.Checked:=(Password.Text<>'');
 Options.DoNotDisturb.Checked:=Ini.ReadBool(id,'DoNotDisturb',False);
 DoNotDisturb2.Checked:=Options.DoNotDisturb.Checked;
 SIP.Accept:=Options.DoNotDisturb.Checked=False;
 Domain.Text:=Ini.ReadString(id,'Domain',Domain.Text);
 Options.SetWaveIn(Ini.ReadString(id,'WaveIn',''));
 Options.SetWaveOut(Ini.ReadString(id,'WaveOut',''));
 SetTabs([tConnexion,tabPhoneBook,tCallHistory,tabOptions,tHelp],tConnexion);
end;

procedure TMainForm.PhoneBookPageShow(Sender: TObject);
begin
 PhoneBook.ReadPhoneBook;
end;

procedure TMainForm.CallHistoryPageShow(Sender: TObject);
begin
 ReadCallHistory;
end;

procedure TMainForm.DisconnectClick(Sender: TObject);
begin
 SetTabs(fTabs-[tStatus]+[tWait],tWait);
 SIP.Logout;
end;

procedure TMainForm.HangupClick(Sender: TObject);
begin
 SetTabs([tWait,tHelp],tWait);
 SIP.Cancel; // voir SIP.OnXXX pour les changements
 RTCP.Leave;
 PCMA.Close;
end;

procedure TMainForm.Dial(const Number:string);
begin
 Status.Caption:='Appel de '+Number+' en cours';
 Cancel.Caption:='ANNULER';
 Cancel.Tag:=0;
 SetTabs([tWait,tHelp],tWait);
 SIP.Dial(Number);
end;

procedure TMainForm.DoNotDisturbClick(Sender: TObject);
var
 b:boolean;
begin
 b:=TCheckBox(Sender).Checked;
 if TCheckBox(Sender).Tag=1 then begin
  Options.DoNotDisturb.Checked:=b;
 end else begin
  DoNotDisturb2.Checked:=b;
 end;
 Ini.WriteBool(UserID.Text,'DoNotDisturb',b);
 SIP.Accept:=(b=False);
end;

end.

